; Copyright (C) Intel Corporation 1996
;         All Rights Reserved.
;INTEL LICENSE AGREEMENT 
; SAMPLE RISM SOURCE CODE  
;
;IF YOU USE THIS SAMPLE RISM SOURCE CODE, YOU WILL BE BOUND BY THE TERMS OF THIS AGREEMENT.  DO ;NOT USE THE Source SAMPLE RISM SOURCE CODE UNTIL YOU HAVE CAREFULLY READ AND AGREED TO THE ;FOLLOWING TERMS AND CONDITIONS.  IF YOU DO NOT AGREE TO THE TERMS OF THIS AGREEMENT, PROMPTLY ;RETURN OR DESTROY THE SAMPLE RISM SOURCE CODE AND ANY ACCOMPANYING ITEMS.
;
;LICENSE: Intel grants you the non-exclusive right to use the enclosed sample RISM source code ;software, ("Sample RISM Source Code").  You will not use, copy, distribute, publicly display, ;modify, rent, sell or transfer the Sample RISM Source Code or any portion thereof except as ;provided in this Agreement. 
;
;You may:
;1.	Install/Use the Sample RISM Source Code internally, including over your company network; 
;2.	Copy the Sample RISM Source Code for backup or archive purposes;
;3.	Modify the Sample RISM Source Code to suit your USB application that is designed for use 	;only with an Intel USB microcontroller;
;4.	Incorporate the object code version of the Sample RISM Source Code as modified by you 	;into your USB hardware product containing an Intel USB microcontroller.  
;
;You will not:
;1.	Sublicense the Sample RISM Source Code in source code form;
;2.	Copy, redistribute, or use the Sample RISM Source Code, in whole or in part, except as 	;provided in this Agreement.
;
;OWNERSHIP AND COPYRIGHT OF SAMPLE RISM SOURCE CODE:  Title to the Sample RISM Source Code and ;all copies thereof remain with Intel or its vendors.  The Sample RISM Source Code is ;copyrighted and is protected by United States copyright laws and international treaty ;provisions.  You will not remove the copyright notice from the Sample RISM Source Code.  You ;agree to prevent any unauthorized copying of the Sample RISM Source Code.  Nothing in this ;Agreement shall be construed to prevent Intel from licensing the Sample RISM Source Code to ;third parties.
;
;DISCLAIMER:  THE SAMPLE RISM SOURCE CODE IS PROVIDED "AS IS" WITHOUT ANY EXPRESS OR IMPLIED ;WARRANTY OF ANY KIND INCLUDING WARRANTIES OF MERCHANTABILITY, NONINFRINGEMENT OF INTELLECTUAL ;PROPERTY, OR FITNESS FOR ANY PARTICULAR PURPOSE.  IN NO EVENT SHALL INTEL OR ITS SUPPLIERS BE ;LIABLE FOR ANY DAMAGES WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF PROFITS, ;BUSINESS INTERRUPTION, LOSS OF INFORMATION) ARISING OUT OF THE USE OF OR INABILITY TO USE THE ;SAMPLE RISM SOURCE CODE, EVEN IF HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.  Intel ;further does not warrant the accuracy or completeness of the Sample RISM Source Code or ;information, text, or other items contained within the Sample RISM Source Code.  Intel may make ;changes to the Sample RISM Source Code at any time without notice.  Intel makes no commitment ;to update the Sample RISM Source Code.  
;
;INDEMNITY:   You will defend or settle any suit or proceeding brought against Intel concerning ;your use or sale of the Sample RISM Source Code or associated object code including but not ;limited to:  (a) any warranty claims concerning the Sample RISM Source Code by your customers;  ;(b) any product liability claims by your customers.
;
;USER RESPONSIBILITY:  You assume sole responsibility for testing the Sample RISM Code and its ;associated object code, and ensuring that the associated object code will meet your ;requirements for use in your USB hardware products.  
;
;AUDIT:  Intel reserves the right to conduct or have conducted audits to verify your compliance ;with this Agreement.
;
;TERMINATION OF THIS LICENSE:  Intel may terminate this license at any time if you are in breach ;of any of its terms and conditions.  Upon termination, you will immediately destroy the Sample ;RISM Source Code or return all copies of the Sample RISM Source Code and documentation to Intel ;along with any copies you have made.
;
;U.S. GOVERNMENT RESTRICTED RIGHTS:  The Sample RISM Source Code and documentation are provided ;with "RESTRICTED RIGHTS."  Use, duplication or disclosure by the Government is subject to ;restrictions as INTEL set forth in FAR52.227-14 and DFAR252.227-7013 et seq. or its successor.  ;The use of this Sample RISM Source Code by the Government constitutes acknowledgment of Intel's ;proprietary rights in the Sample RISM Source Code.;
;
;ENTIRE AGREEMENT:  This Agreement constitutes the entire agreement between the parties and ;supersedes any prior or contemporaneous oral or written agreements,. 
;
;APPLICABLE LAWS:  Intel makes no representation that the Sample RISM Source Code is appropriate ;or available for use in locations outside the United States, and access to it from territories ;where its contents are illegal or prohibited.  Those who choose to access this Sample RISM ;Source Code from locations outside the United States do so on their own initiative and are ;responsible for compliance with applicable local laws.  You may not use or export the Sample ;RISM Source Code in violation of U.S. export laws and regulations.  Any claim relating to the ;Sample RISM Source Code shall be governed by the internal substantive laws of the State of ;Delaware. 
;
; The Software is provided "AS IS."
;
; LIMITATION OF LIABILITY:    NEITHER INTEL NOR ITS VENDORS OR AGENTS 
;    SHALL BE LIABLE FOR ANY LOSS OF PROFITS, LOSS OF USE, LOSS OF DATA, 
;    INTERRUPTION OF BUSINESS, NOR FOR INDIRECT, SPECIAL, INCIDENTAL OR 
;    CONSEQUENTIAL DAMAGES OF ANY KIND WHETHER UNDER THIS AGREEMENT OR 
;    OTHERWISE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
;
;
; RISM CODE FOR 8x930Ax                  RISMB2.ASM     REV 2.1,  8/1/96
;
; always configure the following, and chip configuration bytes

 USBRISM        equ 1              ; 1 for USB rism
 SRCMODE        equ 0              ; 0 for binary mode, 1 for source mode
 EXT_MEMORY     equ 004000H        ; 004000H for USB bd 
 EXTINTR        equ 0              ; 0 for INT0#, 1 for INT1#
 TIMER          equ 2              ; 2 for timer2, 1 for timer1

;system frequency   12.000000 MHz                
        sysfrq1         equ 00h  
        sysfrq2         equ 00h 
        sysfrq3         equ 00h 
        sysfrq4         equ 12h

        Reset_page      equ 0FFH
        dvice_ID        equ 0A1H       

;internal_break_bit  bit     P3.5

        UART_baud_rate equ 0006h        ; 19200  baud for 1.8432MHz Crystal

        UART_base_address       equ     FF:FFC0H

        THR_write       equ     0
        DLL_write       equ     0
        DLM_write       equ     1
        IER_write       equ     1
        FCR_write       equ     2
        LCR_write       equ     3
        MCR_write       equ     4
        LSR_write       equ     5
        MSR_write       equ     6
        SCR_write       equ     7

        RBR_read        equ     0
        DLL_read        equ     0
        DLM_read        equ     1
        IER_read        equ     1
        IIR_read        equ     2
        LCR_read        equ     3
        MCR_read        equ     4
        LSR_read        equ     5
        MSR_read        equ     6
        SCR_read        equ     7

        
        CSEG                                
        ORG 0FF7FF8h    ;Configuration Bytes
        DB  11010010B, 11110111B                ; B-NP

        DSEG
        ORG 000029H     ; RISM data
 
mod:             DS      1                     
;         DLEmode             bit      mod.0
;         read_xmit_flag      bit      mod.1
;         step_enabled        bit      mod.2
;         reserved_3          bit      mod.3
;         diagnostic          bit      mod.4
;         external_serial     bit      mod.5
;         user_break          bit      mod.6 
;         userruns            bit      mod.7
;
selector:        DS      1                    
;         int_regs            bit      selector.0
;         reserved            bit      selector.1
;         reserved            bit      selector.2
;         SFR_space           bit      selector.3
;

RISM_DATA:       DS      4                          
RISM_ADDR:       DS      4                    
user_PC:         DS      4                
char:            DS      1                   
BAUD_RATE:
Bd_rate:         DS      1  
Bd_rate1:        DS      1  
Bd_change:       DS      1           

        CSEG
        ORG 0FF0000H    ; RISM code
;RESET vector
        Ljmp   main                  ; MUST be LJMP

        ORG  0FF0003H                ; int0   interrupt vector
    IF EXTINTR==0
        eJMP    External_isr
    ENDIF
    IF EXTINTR==1
        eJMP   EXT_MEMORY+03h
    ENDIF

        ORG   0FF000BH               ; timer0 interrupt vector
        eJMP   EXT_MEMORY+0Bh

        ORG   0FF0013H               ; int1   interrupt vector
    IF EXTINTR==0
        eJMP   EXT_MEMORY+13h
    ENDIF
    IF EXTINTR==1
        eJMP    External_isr
    ENDIF

        ORG   0FF001BH               ; timer1 interrupt vector
        eJMP   EXT_MEMORY+1Bh

        ORG   0FF0023H               ; serial port interrupt vector
        eJMP   Serial_isr

        ORG   0FF002BH               ; timer2 interrupt vector
        eJMP   EXT_MEMORY+2Bh

        ORG   0FF0033H               ; PCA    interrupt vector
        eJMP   EXT_MEMORY+33h

    IF USBRISM
        ORG   0FF0043H               ; USB HUB Interrupt vector
        eJMP   EXT_MEMORY+43h
        
        ORG   0FF004BH               ; USB FUNCTION Interrupt vector
        eJMP   EXT_MEMORY+4Bh

        ORG   0FF0053H               ; USB GLOBAL SUSPEND/RESUME Interrupt vector
        eJMP   EXT_MEMORY+53h
        
        ORG   0FF0083H
        eJMP  SETB_LC

        ORG   0FF008BH
        eJMP  CLRB_LC
    ENDIF


        ORG   0FF007BH               ; THE BREAK - TRAP
        eJMP   Break


        org 0FF00FEh

        DB 0B2H,21H   ;***    RISMB2.ASM   REV 2.1 

;
; PLLSEL handling
;

    IF USBRISM

SETB_LC:
        JB mod.5, EXT_SET
        CLR EA
        MOV  T2CON,#00110000B     
        MOV RCAP2H, Bd_rate1
        MOV RCAP2L, Bd_rate
        SETB T2CON.2                            ; start timer 2
        SETB PCON.5
        SETB EA
        eRET
EXT_SET:
        SETB PCON.5 
        eRET
        
CLRB_LC: 
        JB mod.5, EXT_CLR
        CLR EA
        CLR  PCON.5
        MOV  T2CON,#00110000B     
        MOV  RCAP2H, Bd_rate1
        MOV  RCAP2L, Bd_change
        SETB T2CON.2                            ; start timer 2
        SETB EA
        eRET
EXT_CLR:
        CLR  PCON.5
        eRET

    ENDIF

Serial_app:
        eJMP EXT_MEMORY+23h

External_app:
IF EXTINTR==0
        eJMP EXT_MEMORY+03H
ENDIF
IF EXTINTR==1
        eJMP EXT_MEMORY+13H
ENDIF 


;
;  Serial Port Interrupt Service Routine
;

                  
Serial_isr:                                     ;***
        JB    mod.5, Serial_app                 ; if Ext UART, go to applications.
        JB    mod.2, Internal_Step_vector       ; if step enabled, jmp
        JMP Internal_RISM_isr         

Internal_Step_vector:
        CLR   RI
        CLR   mod.2                             ; disable the step interrupt
        LJMP  Break                             ; process like a normal break

Internal_RISM_isr:
        JB    RI,Internal_receive_ready         ; go receive.
        CLR   TI                                ; It was just a transmit
        RETI

Internal_receive_ready:
        JNB   mod.4, Internal_start_RI_ISR      ; if diag bit is not set do monitor
        MOV   R11,SBUF                          ; else, get character
        CLR   RI
         
        INC   R11,#1                            ; increment it
        MOV   SBUF,R11                          ; and transmit it back out
        CLR   TI        
        DEC   R11,#1
        CMP   R11,#'/'
        JNE   Internal_Diag_check_0           
        SJMP  Internal_Diag_check_1
Internal_Diag_check_0:
        CMP   R11,#'\'
        JNE   Internal_Rec_red                
Internal_Diag_check_1:
        CLR   mod.4
        
        MOV R0, #0h
        PUSH R0                                         
        MOV WR0, #high16(Monitor_continue)
        PUSH R1         ; high

        MOV   WR0,#LOW16(Monitor_continue)     
        PUSH  R1        ; push address   
        PUSH  R0       
                               
        RETI
Internal_Rec_red:
        MOV     P1,R11
        RETI
;
;          if the diagnostic flag is not set the code continues here.
;
Internal_start_RI_ISR:
        PUSH    PSW
        PUSH    DR8                     ; RISM uses DR8 register (must stack it)
        PUSH    WR0
        MOV     R1,SBUF        
        MOVZ    WR0,R1
        MOV     char,R1
        CLR     RI
        JMP Continue_point

;
;  External Interrupt Service Routine
;


External_isr:                           ;***
        JNB mod.5, External_ap
        JB  mod.2, External_Step_vector
        JMP External_RISM_isr  
External_ap:
        JMP External_app

External_Step_vector:  
    IF EXTINTR==0
        SETB P3.2
    ENDIF
    IF EXTINTR==1                 
        SETB P3.3
    ENDIF
        CLR mod.2                               ; disable the step interrupt
        LJMP Break                              ; process like a normal break

External_RISM_isr:
        PUSH PSW
        PUSH DR8
        PUSH WR0
        MOV WR8, #HIGH16(UART_base_address)
        MOV WR10, #LOW16(UART_base_address)
        XRL R1, R1
        MOV R1, @DR8+IIR_read

        CMP R1, #04H
        JE External_receive_ready

        MOV R1, #01H
        MOV @DR8+IER_write, R1

        POP WR0
        POP DR8
        POP PSW
        RETI

External_receive_ready:
        JNB   mod.4, External_start_RI_ISR       ; if diag bit is not set do monitor
        MOV   R1, @DR8+RBR_read                  ; else, get character
         
        INC   R1,#1                              ; increment it
        MOV   @DR8+THR_write, R1                 ; and transmit it back out
        DEC   R1,#1
        CMP   R1,#'/'
        JNE   External_Diag_check_0           
        SJMP  External_Diag_check_1
External_Diag_check_0:
        CMP   R1,#'\'
        JNE   External_Rec_red                
External_Diag_check_1:
        CLR   mod.4

        POP WR0
        POP DR8
        POP PSW
        
        MOV R0, #0h
        PUSH R0                                                             
        MOV WR0, #high16(Monitor_continue)
        PUSH R1                                         ; high

        MOV   WR0,#LOW16(Monitor_continue)     
        PUSH  R1                                        ; low   
        PUSH  R0                                        ; mid
                               
        RETI
External_Rec_red:
        MOV     P1,R1
        POP WR0
        POP DR8
        POP PSW
        RETI
;
;          if the diagnostic flag is not set the code continues here.
;
External_start_RI_ISR:

        MOV     R1,@DR8+RBR_read       
        MOVZ    WR0,R1
        MOV     char,R1

;
;       Control passes here after an internal/external serial I/O interrupt (RISM)
;


Continue_point:                         ; for either INTERNAL or EXTERNAL UART
        JNB     mod.0,keep_going
        LJMP    Force_load_data         ; DLE flag is set
keep_going:
        CMP     R1,#1fH
        JLE     process_command
        LJmp    load_data               ; commands are <= 1FH
process_command:
        CLR     C
        MOV     WR8,#Reset_page
        SLL     WR0
        ADD     WR0,#LOW16(Command_table)
        MOV     WR10,WR0
        MOV     WR10,@DR8               ; point to high byte of vector
        eJMP    @DR8
;
; -------------------------------------------------------
;
;
Break:
;----
; This routine is invoked for breakpoint trap,
; it operates somewhat like a HALT instruction.
        
        JB      mod.6, do_not_break    
        JNB     mod.7, do_not_break           
       
        
        PUSH    PSW
        PUSH    DR8
        PUSH    WR0

        MOV     DR8,SPX
        SUB     WR10,#0008H             ; point to User_PSW
        MOV     WR0,@DR8                ;
        MOV     user_PC+2,R1            ; POP off the user mid address
        MOV     user_PC+3,R0            ; POP off the user low address
        DEC     DR8,#1
        MOV     R1,@DR8
        MOV     user_PC+1,R1            ; POP off the user high address 
        MOV     R0, #00h
        MOV     user_PC, R0
        
        CLR     mod.7                   ; clear user running flag
        SETB    mod.6                   ; set break flag
        SETB    P3.5                
        
        ;get them out of the stack 

        MOV     R0,#Reset_page          ; hi Address
        MOV     @DR8,R0
        ADD     DR8,#1
        MOV     WR0,#LOW16(Monitor_pause)
        MOV     @DR8,R1                 ; low address
        ADD     DR8,#1
        MOV     @DR8,R0                 ; mid Address

        POP     WR0
        POP     DR8
        POP     PSW
do_not_break:
        RETI  


;
;
Command_table:
        DW        Set_DLE             ; 00
        DW        Xmit                ; 01
        DW        Xmita               ; 02
        DW        Exit                ; 03
        DW        Read_byte           ; 04
        DW        Read_word           ; 05
        DW        Read_long           ; 06
        DW        Write_byte          ; 07
        DW        Write_word          ; 08
        DW        Write_long          ; 09
        DW        Data_to_addr        ; 0A
        DW        Indirect0           ; 0B
        DW        Read_PSW            ; 0C
        DW        Write_PSW           ; 0D
        DW        Read_SP             ; 0E
        DW        Write_SP            ; 0F
        DW        Read_PC             ; 10
        DW        Write_PC            ; 11
        DW        Go                  ; 12    
        DW        Halt                ; 13
        DW        Report              ; 14
        DW        Read_byte_xmita     ; 15
        DW        Exit                ; 16
        DW        Read_baud           ; 17
        DW        Write_selector      ; 18
        DW        Exit                ; 19 
        DW        Exit                ; 1A 
        DW        Step                ; 1B
        DW        Write_baud          ; 1C
        DW        Read_frequency      ; 1D
        DW        Report_device       ; 1E
        DW        Exit                ; 1F
                       
;
Force_load_data:
;--------------
        CLR     mod.0                           ;  clear DLE flag
load_data:
;--------
        MOV     DR8, RISM_DATA
        MOV     R8,R9
        MOV     R9,R10
        MOV     R10,R11
        MOV     R11,char
        MOV     RISM_DATA,DR8
        LJMP    Exit 

;
;  RESET  Code starts Here!
;
;        
main:    
Reset_vector:
        CLR     EA                              ; disable interrupts


; Check for External Serial Port option
        MOV WR8, #HIGH16(UART_base_address)
        MOV WR10, #LOW16(UART_base_address)
        CLR mod.5                               ; assume no external UART
        MOV R1, @DR8+SCR_read
        XRL R1, #0FFH
        MOV @DR8+SCR_write, R1
        MOV R0, R1
        MOV R1, @DR8+SCR_read
        CMP R1, R0
        JNE No_External
        ;MOV R1, @DR8+LSR_read
        ;CJNE R1, #60H, No_External
        MOV R1, @DR8+IIR_read
        CJNE R1, #01H, No_External
Yes_External:
        SETB mod.5
No_External:


IF USBRISM  ; start usb reset handling
Check_Reset:                                    ; cold reset or warm reset?

        MOV R1, S:87H
        ANL R1, #10H
        CJNE R1, #00H, Cold
        JB mod.7, Warm_Reset
Cold:
        LJMP Cold_Reset                         ; goto cold reset

Warm_Reset:
        MOV     SPX,#03E0H                      ; initialize stack pointer

        MOV R1, #01H                            ; make a running status
        MOV RISM_DATA+3, R1

        JB mod.5, External_Running

Internal_Running:

    IF TIMER==2
        ; Set timer 2 for baud rate generator
        MOV  T2CON,#00110000B                   ; timer 2 mode BRG
        MOV  R1, Bd_rate1
        MOV  RCAP2H,R1                          
        MOV  R1, Bd_rate
        MOV  RCAP2L,R1                          ; keep earlier baud rate
        SETB T2CON.2                            ; start timer 2
    ENDIF
    IF TIMER==1
        MOV     TMOD,#00100000B                 ; timer 1 mode 2
        MOV     R1, Bd_rate        
        MOV     TH1, R1                         ; keep earlier baud rate 
        MOV     R1, Bd_rate1
        CMP     R1, #00H
        JE SMOD1_Done
        SETB S:87H.7
        SMOD1_Done:
        SETB    TR1                             ; start timer 1
    ENDIF

        ; Initalize serial port
        MOV     SCON,#01010000B                 ; mode 1 

        MOV R1, #01H
        MOV SBUF, R1
        CLR TI
        XRL R1, R1

        ; Initialize interrupts
        SETB    PS                            ; set interrupt to highest priority
        ORL     0B7H,#10H                     ; SET PSH in IPH  
        SETB EA
        SETB ES
        EJMP EXT_MEMORY


External_Running:

        MOV WR8, #HIGH16(UART_base_address)
        MOV WR10, #LOW16(UART_base_address)

        MOV R1, #80H               
        MOV @DR8+LCR_write, R1                  ; set DLAB bit
        
        MOV R1, Bd_rate     
        MOV @DR8+DLL_write, R1                  ; load baud rate low, keep earlier baud rate

        MOV R1, Bd_rate1          
        MOV @DR8+DLM_write, R1                  ; load baud rate high
        
        MOV R1, #03H           
        MOV @DR8+LCR_write, R1                  ; reset DLAB, NP, 8bit, 1stop,  ...
        
        MOV R1, #01H              
        MOV @DR8+IER_write, R1                  ; enable receive FIFO interrupts

        MOV R1, #01H
        MOV   @DR8+THR_write, R1                ; transmit it back out
        MOV DR8, #0H
        XRL R1, R1

; Initialize interrupts        
    IF EXTINTR==0
        SETB IPH0.0                             ; external interrupt 0 priority bit high
        SETB IPL0.0                             ; external interrupt 0 priority bit low
        SETB EX0
    ENDIF
    IF EXTINTR==1
        SETB IPH0.2                             ; external interrupt 1 priority bit high
        SETB IPL0.2                             ; external interrupt 1 priority bit low
        SETB EX1
    ENDIF                
        SETB EA
        EJMP EXT_MEMORY

Cold_Reset:

        MOV R0, S:87H
        MOV R1, #0EFH
        ANL R0, R1
        MOV S:87H, R0
        MOV WR0, #0H


ENDIF  ; end usb reset handling

        JB mod.5, Init_External

Init_Internal:

    IF TIMER==2
        ; Set timer 2 for baud rate generator
        MOV  T2CON,#00110000B                   ; timer 2 mode BRG
        MOV  RCAP2H, #0FFH                      ; set timer 2 reload value
    IF USBRISM
        MOV  RCAP2L,#0ECH                       ; 9.6k for core of 3 MHz
    ENDIF
    IF !USBRISM
        MOV  RCAP2L,#0E6H                       ; 19.2k for 16MHz crystal
                                                ; configure this for different
                                                ; baud or frequency from the formula
    ENDIF
        SETB T2CON.2                            ; start timer 2

    IF USBRISM
        ; PLLSEL handling
        MOV Bd_change, RCAP2L
        MOV ACC, S:0DFH
        JB ACC.5, CORE3MHZ
        JB ACC.6, CORE12MHZ
        JB ACC.7, CORE6MHZ
        JMP freq_done

CORE3MHZ:                       ; PLLSEL2==? PLLSEL1==? PLLSEL0==1 
        JB ACC.6, freq_done     ; PLLSEL2==? PLLSEL1==1 PLLSEL0==1  
        JB ACC.7, freq_done     ; PLLSEL2==1 PLLSEL1==0 PLLSEL0==1  
                                ; PLLSEL2==0 PLLSEL1==0 PLLSEL0==1  
        JMP freq_done

CORE12MHZ:                      ; PLLSEL2==1 PLLSEL1==? PLLSEL0==0  
        JNB ACC.6, freq_done    ; PLLSEL2==1 PLLSEL1==0 PLLSEL0==0 
                                ; PLLSEL2==1 PLLSEL1==1 PLLSEL0==0 
        MOV Bd_change, #0B2H
        JMP freq_done

CORE6MHZ:                       ; PLLSEL2==1 PLLSEL1==0 PLLSEL0==0
        MOV Bd_change, #0D9H
        JMP freq_done

freq_done:
    ENDIF


    ENDIF
    IF TIMER==1
        MOV     TMOD,#00100000B                 ; timer 1 mode 2
        MOV     TH1, #0FDH                      ; to get 9.6k baud at 11.0592 Mhz
                                                ; configure this for different
                                                ; baud or frequency from the formula      
        SETB    TR1                             ; start timer 1
    ENDIF


      
        ; Initalize serial port
        MOV     SCON,#01010000B                 ; mode 1 

        ; Initialize interrupts
        SETB    PS                              ; set interrupt to highest priority
        ORL     0B7H,#10H                       ; SET PSH in IPH  

    IF TIMER==2
        MOV     R0,RCAP2L                       ; RCAP2L
        MOV     Bd_rate, R0
        MOV     R0, RCAP2H
        MOV     Bd_rate1, R0
    ENDIF
    IF TIMER==1
        MOV R0, TH1
        MOV Bd_rate, R0
        MOV R0, S:87H
        ANL R0, #80H
        MOV Bd_rate1, R0
    ENDIF

        JMP Init_Done

; Initialize External UART

Init_External:
        MOV WR8, #HIGH16(UART_base_address)
        MOV WR10, #LOW16(UART_base_address)

        MOV R1, #80H               
        MOV @DR8+LCR_write, R1                  ; set DLAB bit
        
        MOV R1, #LOW(UART_baud_rate)      
        MOV @DR8+DLL_write, R1                  ; load baud rate low

        MOV R1, #HIGH(UART_baud_rate)          
        MOV @DR8+DLM_write, R1                  ; load baud rate high
        
        MOV R1, #03H           
        MOV @DR8+LCR_write, R1                  ; reset DLAB, NP, 8bit, 1stop,  ...
        
        MOV R1, #01H              
        MOV @DR8+IER_write, R1                  ; enable receive FIFO interrupts

        MOV     R0, #LOW(UART_baud_rate)
        MOV     Bd_rate, R0
        MOV     R0, #HIGH(UART_baud_rate)
        MOV     Bd_rate1, R0

Init_Done:

        MOV WR0, #HIGH16(EXT_MEMORY)
        MOV user_PC, R0
        MOV user_PC+1, R1
        MOV     WR0,#LOW16(EXT_MEMORY)
        MOV     user_PC+2,R0
        MOV     user_PC+3,R1                    ; user PC will RESET to start
     
        MOV R0, mod
        ANL R0, #20H
        ORL R0, #10H
        MOV mod, R0                             ; initialize rism mode register

        JB mod.5, External_LEDs

Internal_LEDs:
        SETB    EA                              ; global interrupt enable        
        SETB    ES                              ; enable serial port interrupt
        LCALL    Flash_LEDs   

        JMP Monitor_continue

External_LEDs:
        ; Initialize interrupts       
    IF EXTINTR==0
        SETB IPH0.0                             ; external interrupt 0 priority bit high
        SETB IPL0.0                             ; external interrupt 0 priority bit low
        SETB EX0                                ; enable external interrupt 1
    ENDIF
    IF EXTINTR==1
        SETB IPH0.2                             ; external interrupt 1 priority bit high
        SETB IPL0.2                             ; external interrupt 1 priority bit low
        SETB EX1                                ; enable external interrupt 1
    ENDIF                 
        SETB EA                                 ; enable global interrupt
        LCALL Flash_LEDs


Monitor_continue:
        MOV     SPX, #3E0H                      ; Reload Stack Pointer
        MOV     P1, #055H                       ; LEDs = 55H
        MOV     R11,#00h
        MOV DR0, #0H
        MOV DR4, #0H
        MOV DR8, #0H



Monitor_pause:
        SJMP     Monitor_pause

;
Flash_LEDs:
        MOV    R11,#01H
        MOV    R0,#0
        MOV    R1,#0
Flash_loop:
        SETB   C
        MOV    P1,R11
Flash_wait:
        DJNZ   R0,Flash_wait
        DJNZ   R1,Flash_wait
        SLL    R11
        JNZ    Flash_loop
        RET

;
;
Set_DLE:    ;00
;------
        SETB    mod.0                   
        LJMP    Exit
;
Xmit:      ;01
;---
;  The byte to be transmited is put in the location
;  char. the data register is shifted byte-wise
 
        MOV     DR8, RISM_DATA
        MOV     char,R11
        MOV     R11,R10
        MOV     R10,R9
        MOV     R9,R8
        MOV     RISM_DATA,DR8
        LJMP    Xmit_exit
;
Xmita:     ;02
;---
;  The byte to be transmited is put in the location
;  char. the data register is shifted byte-wise and 
;  the address register is incremented by 1
 
        MOV     DR8, RISM_DATA
        MOV     char,R11
        MOV     R11,R10
        MOV     R10,R9
        MOV     R9,R8
        MOV     RISM_DATA,DR8
        MOV     DR8,RISM_ADDR
        ADD     DR8,#1
        MOV     RISM_ADDR,DR8
        CLR     mod.1                           ; clear the read_xmit_flag
;
Xmit_exit:
;--------
; 
        MOV R1,char                             ; send char out to the PC
        JNB mod.5, Xmit_internal
        MOV WR8, #HIGH16(UART_base_address)
        MOV WR10, #LOW16(UART_base_address)
        MOV @DR8+THR_write, R1
        SJMP Exit
Xmit_internal:
        MOV SBUF, R1
        CLR TI
;
;
Exit:
        POP     WR0
        POP     DR8
        POP     PSW
        RETI
;
;
Write_byte:         ; 07
        JB      selector.0,Write_REG_bytea
        JB      selector.3,Write_SFR_bytea

Write_a_byte:
Write_a_bytea:
;----------
; @addr:=data
; addr:=addr+1
        MOV     DR8,RISM_ADDR           ; get address to write
        MOV     R0,RISM_DATA+3          ; get data
        MOV     @DR8,R0                 ; Store DATA byte
        ADD     DR8,#1                  ; Increment ADDR pointer
        MOV     RISM_ADDR,DR8           ; save new address
        LJMP    Exit
;
Write_REG_bytea:
;--------------
        MOV     R0,RISM_DATA+3
        MOV     R11,RISM_ADDR+3
        ANL     WR10,#000FH             ; mask off upper bits
        SLL     WR10
        SLL     WR10                    ; multiply by 4
        ADD     WR10,#LOW16(Write_REG_table)
        LCALL   @WR10                   ; start execution
        MOV     DR8,RISM_ADDR
        ADD     DR8,#1
        MOV     RISM_ADDR,DR8
        LJMP    Exit
;
Write_SFR_byte:
Write_SFR_bytea:
;----------
; @addr:=data
; addr:=addr+1
        MOV     R0,RISM_DATA+3
        MOV     R11,RISM_ADDR+3
        ANL     WR10,#007FH             ; mask off upper bit
        SLL     WR10
        SLL     WR10                    ; multiply by 4
        ADD     WR10,#LOW16(Write_SFR_table)
        LCALL   @WR10                   ; start execution
        MOV     DR8,RISM_ADDR
        ADD     DR8,#1
        MOV     RISM_ADDR,DR8
        LJMP    Exit
;
Read_byte:           ; 04
        JB      selector.0,Read_REG_byte
        JB      selector.3,Read_SFR_byte

Read_a_byte:
;-----------
; data:=@addr
        MOV     DR8,RISM_ADDR
        MOV     R0,@DR8
        MOV     RISM_DATA+3,R0
        JNB     mod.1,no1_xmit
        LJMP    Xmita                   ; if xmit bit set
no1_xmit:
        LJMP    Exit
;
Read_byte_xmita:
;---------------
        SETB    mod.1
        LJMP    Read_byte
;
Read_REG_byte:
;------------
        MOV     R11,RISM_ADDR+3
        ANL     WR10,#000FH             ; mask off upper bits
        SLL     WR10
        SLL     WR10                    ; multiply by 4
        ADD     WR10,#LOW16(Read_REG_table)
        LCALL   @WR10                   ; start execution
        MOV     RISM_DATA+3,R0          ; store read byte in data reg
        JNB     mod.1,no2_xmit
        LJMP    Xmita
no2_xmit:
        LJMP    Exit
;
Read_SFR_byte:
;---------
; data:=@addr
        MOV     R11,RISM_ADDR+3
        ANL     WR10,#007FH             ; mask off upper bit
        SLL     WR10
        SLL     WR10                    ; multiply by 4
        ADD     WR10,#LOW16(Instruction_table)
        LCALL   @WR10                   ; start execution
        MOV     RISM_DATA+3,R0          ; store read byte in data reg
        JNB     mod.1,no3_xmit
        LJMP    Xmita
no3_xmit:
        LJMP    Exit
;
Read_word:      ; 05
        JB      selector.0,Read_REG_word
        JB      selector.3,Read_SFR_word

Read_a_word:
; data:=@addr


        MOV     DR8,RISM_ADDR
        MOV     WR0,@DR8
        MOV     RISM_DATA+2,R0
        MOV     RISM_DATA+3,R1
        LJMP    Exit
;
Read_REG_word:
;
        MOV     R11,RISM_ADDR+3         ; 0-1FH
        ANL     WR10,#001EH             ; mask off upper bits (word align)
        SLL     WR10                    ; multiply by 2
        ADD     WR10,#LOW16(Read_WR_table)
        LCALL   @WR10                   ; start execution
        MOV     RISM_DATA+2,R0          ; store read word in data reg
        MOV     RISM_DATA+3,R1
        LJMP    Exit
;
Read_SFR_word:
; data:=@addr
;       Not supported 
        LJMP    Exit
;
Read_long:        ; 06
        JB      selector.0,Read_REG_long
        JB      selector.3,Read_SFR_long
;
Read_a_long:
; data:=@addr
; data+2:=@addr+2.@addr+3
        MOV     DR8,RISM_ADDR
        MOV     WR0,@DR8
        MOV     RISM_DATA,WR0
        ADD     DR8,#2
        MOV     WR0,@DR8
        MOV     RISM_DATA,WR0
        LJMP    Exit
;
Read_REG_long:
        MOV     R11,RISM_ADDR+3         ; 0-3FH
        ANL     R11,#3CH                ; mask off upper bits (dword align)
        CMP     R11,#38H
        JE      Read_DR56
        LJMP    Exit
;
Read_DR56:
        MOV     RISM_DATA,DPX
        LJMP    Exit
;
Read_SFR_long:
; 
        MOV     WR8,#0
        MOV     WR10,#0
        MOV     RISM_DATA, DR8
        LJMP    Exit
;
Write_word:        ; 08
        JB      selector.0, Write_REG_word
        JB      selector.3, Write_SFR_word
;
Write_a_word:
;---------
; @addr,@addr+1:=data
; addr:=addr+2
        MOV     DR8,RISM_ADDR
        MOV     WR0,RISM_DATA+2
        MOV     @DR8,WR0
        ADD     DR8,#2
        MOV     RISM_ADDR,DR8
        LJMP    Exit
;
Write_REG_word:
;
        MOV     WR0,RISM_DATA+2
        MOV     R11,RISM_ADDR+3         ; 0-1FH
        ANL     WR10,#001EH             ; mask off upper bits (word align)
        SLL     WR10                    ; multiply by 2
        ADD     WR10,#LOW16(Write_WR_table)
        LCALL   @WR10                    ; start execution
        LJMP    Exit
;
Write_SFR_word:
;---------
; @addr,@addr+1:=data
; addr:=addr+2
;       Not supported yet
        LJMP    Exit
;
Write_long:     ; 09
        JB      selector.0,Write_REG_long
        JB      selector.3,Write_SFR_long
;
Write_a_long:
;---------      
; @addr,@addr+1:=data
; @addr+2.@addr+3:=data+2
; addr:=addr+4
        MOV     DR8,RISM_ADDR
        MOV     WR0,RISM_DATA+2
        MOV     @DR8,R1
        ADD     DR8,#1
        MOV     @DR8,R0
        ADD     DR8,#1
        MOV     WR0,RISM_DATA
        MOV     @DR8,R1
        ADD     DR8,#1
        MOV     @DR8,R0
        ADD     DR8,#1
        MOV     RISM_ADDR,DR8
        LJMP    Exit
;
Write_REG_long:
        MOV     R11,RISM_ADDR+3
        ANL     R11,#3CH
        CMP     R11,#38H
        JE      Write_DR56
        LJMP    Exit
Write_DR56:
        MOV     DPX,RISM_DATA
        LJMP    Exit
;
Write_SFR_long:
;---------      
; @addr,@addr+1:=data
; @addr+2.@addr+3:=data+2
; addr:=addr+4
; Not supported yet
        LJMP    Exit
;
Data_to_addr:    ;0A
;-----------
; addr := data (32 bits)
; 
        MOV     DR8,RISM_DATA
        MOV     RISM_ADDR,DR8
        LJMP    Exit
; 
Indirect0:       ; 0B
;       JNB     selector.3,Ind_load
;       JMP     Indirect_SFR                        
;
Ind_load:
;-------
; addr:=@addr
        MOV     DR8,RISM_ADDR
        MOV     WR0,@DR8       
        MOV     RISM_ADDR,WR0
        MOV     WR0,@DR8+2
        MOV     RISM_ADDR+2,WR0
        LJMP    Exit

Indirect_SFR:
;-------
; N/A
        LJMP    Exit
;

Read_PSW:       ;0Ch
;-------
; data:=User_PSW
; dat+1:=User_PSW1
        MOV     DR8,SPX
        SUB     WR10,#0006H
        MOV     R1,@DR8                         ; PSW
        SUB     WR10,#0004H
        MOV     R0,@DR8                         ; PSW1
        MOV     RISM_DATA+2,WR0
        LJMP    Exit
;
Write_PSW:     ;0Dh
;--------
; User_PSW:=data
; User_PSW:=data+1
        MOV     WR0,RISM_DATA+2
        MOV     DR8,SPX
        SUB     WR10,#0006H
        MOV     @DR8,R1                         ; PSW
        SUB     WR10,#0004H
        MOV     @DR8,R0                         ; PSW1
        LJMP    Exit 
;
Read_SP:     ;0Eh
;------
; data:=User_SP
        JB      mod.7,Read_SP_running
        MOV     DR8,SPX
        SUB     WR10,#000BH
        MOV     RISM_DATA,DR8
        LJMP    Exit
Read_SP_running:
        MOV     DR8,SPX
        MOV     RISM_DATA,DR8
        LJMP    Exit
;
Write_SP:     ;0Fh
;-------
; SP:=data 
        JB      mod.7,Dont_write_SP
        MOV     DR8,RISM_DATA
        MOV     WR8,#0000H
        ADD     WR10,#000AH
        POP     WR0
        MOV     @DR8,WR0
        DEC     DR8,#2
        POP     WR0
        MOV     @DR8,WR0
        DEC     DR8,#2
        POP     WR0
        MOV     @DR8,WR0
        ADD     WR10,#0005H
        MOV     SPX,DR8
        SUB     WR10,#0009H
        LJMP    set_rism_idle
Dont_write_SP:
        LJMP    Exit
;
Read_PC:     ;10h
;------
; data:=User_PC
        JB      mod.7,Read_PC_0
        MOV     DR8,user_PC
        MOV     RISM_DATA,DR8
        LJMP    Exit
Read_PC_0:
        MOV     DR8,SPX
        SUB     WR10,#000AH
        MOV     WR0,@DR8                        ; get PSW and PC high
        MOV     user_PC+1,R1                    ; hi
        MOV     WR0,@DR8+2                      ; get PC mid and low
        MOV     user_PC+3,R0                    ; low
        MOV     user_PC+2,R1                    ; mid
        MOV     R0,#00H
        MOV     user_PC, R0
        LJMP    Exit
;
Write_PC:      ;11h
;-------
; User_PC:=data 
        JB      mod.7,Dont_write_PC
        MOV     DR8,RISM_DATA
        MOV     user_PC,DR8
Dont_write_PC:

        LJMP    Exit
;
Halt:         ;13H
;---
; Stops "user" execution by setting up the stack to return to pause.

        jnb     mod.7, do_not_halt         

        MOV     DR8,SPX                 
                                
        SUB     WR10,#0008H
        MOV     WR0,@DR8                
        MOV     user_PC+2,R1
        MOV     user_PC+3,R0                    ; get low address of PC
        DEC     DR8,#1
        MOV     R0,@DR8
        MOV     user_PC+1,R0                    ; hi address of PC

set_rism_idle:
        MOV     R0,#Reset_page
        MOV     @DR8,R0
        ADD     DR8,#1
        MOV     WR0,#LOW16(Monitor_pause)
        MOV     @DR8,R1
        ADD     DR8,#1
        MOV     @DR8,R0

        CLR     mod.7                           ; not running
        CLR     mod.6                           ; no  break
         
;        SETB    P3.5                 
do_not_halt:
        LJMP    Exit



;
Report:     ; 14h
;-----
; Report user status
        stopped  equ     0
        running  equ     1
        trapped  equ     2
;
;
        MOV     R0,#stopped
        MOV     RISM_DATA+2,R0
        MOV     R0,#running
        MOV     RISM_DATA+3,R0
        JB      mod.7,Report_exit               ; if bit 7=1 report running
        MOV     R0,#trapped
        MOV     RISM_DATA+3,R0
        JB      mod.6,Report_exit               ; if bit 6=1 report trapped
        MOV     R0,#stopped
        MOV     RISM_DATA+3,R0
Report_exit:
        MOV     R0,RISM_DATA+3
        MOV     char, R0
        LJMP    Xmit_exit

;
Read_baud:           ; 17H
        MOV     R1, Bd_rate
        MOV     RISM_DATA+3, R1
        MOV     R1, Bd_rate1
        MOV     RISM_DATA+2, R1
        LJMP    Exit

;
Write_selector:       ;18h
; data:=selector (memory segment select)
        MOV     R0,RISM_DATA+3
        MOV     selector, R0
        LJMP    Exit
;
Read_bit:         ;19
;---------
; not supported 
; data:=@addr
        LJMP     Exit
;
Write_bit:          ;1A
;----------
; not supported
; @addr:=data
        LJMP     Exit
;
Step:                 ; 1B 
        SETB   mod.2                            ; enable the step interrupt
        
        JB mod.5, External_Step
        SETB RI                                 ; cause interrupt to happen after RETI
        SJMP Go

External_Step:
    IF EXTINTR==0                      
        CLR P3.2
        JNB TCON.1, External_Step
    ENDIF
    IF EXTINTR==1
        CLR P3.3
        JNB TCON.3, External_Step
    ENDIF

;
Go:          ;12       
;
; 
        JB      mod.7, do_not_go     
        CLR     P3.5

        MOV     DR8,SPX                         ; calculate the beginning
                                                ;  of the stack upon entry
        SUB     WR10,#0007H
        MOV     R0,user_PC+2
        MOV     @DR8,R0
        DEC     DR8,#1
        MOV     R0,user_PC+3
        MOV     @DR8,R0
        DEC     DR8,#1
        MOV     R0,user_PC+1
        MOV     @DR8,R0

        CLR     mod.6                           ; clear break flag if set
        SETB    mod.7                           ; set user running flag
do_not_go:
        LJMP    Exit
       
;
Write_baud:          ; 1C   
        MOV     R0, RISM_DATA+3
        MOV     Bd_rate,R0

        MOV     R1, RISM_DATA+2
        MOV     Bd_rate1, R1

        JB mod.5, External_Baud

    IF TIMER==2
        MOV  T2CON,#00110000B     
        MOV  RCAP2H, R1             
        MOV  RCAP2L, R0              
        SETB T2CON.2                            ; start timer 2
        JMP Baud_Done
    ENDIF

    IF TIMER==1
        MOV  TH1, R0 
        CMP R1, #00H                            ; SMOD1
        JE Baud_Done
        SETB S:87H.7           
        JMP Baud_Done
    ENDIF

External_Baud:
        MOV WR8, #HIGH16(UART_base_address)
        MOV WR10, #LOW16(UART_base_address)

        MOV R1, #80H               
        MOV @DR8+LCR_write, R1                  ; set DLAB bit
        
        MOV R1, Bd_rate     
        MOV @DR8+DLL_write, R1                  ; load baud rate low

        MOV R1, Bd_rate1          
        MOV @DR8+DLM_write, R1                  ; load baud rate high
        
        MOV R1, #03H           
        MOV @DR8+LCR_write, R1                  ; reset DLAB, NP, 8bit, 1stop,  ...
        
        MOV R1, #01H              
        MOV @DR8+IER_write, R1                  ; enable receive FIFO interrupts
Baud_Done:
        LJMP    Exit
;
Read_frequency:      ; 1D   
        MOV     R0,#sysfrq1
        MOV     RISM_DATA+3,R0    
        MOV     R0,#sysfrq2
        MOV     RISM_DATA+2,R0    
        MOV     R0,#sysfrq3
        MOV     RISM_DATA+1,R0    
        MOV     R0,#sysfrq4
        MOV     RISM_DATA,R0    
        LJMP    Exit
;
Report_device:       ; 1E  
        MOV     R0, #dvice_ID
        MOV     RISM_DATA+3,R0
        LJMP    Exit
;        
;
Read_REG_table:
        LJMP    Read_R0
        NOP
        LJMP    Read_R1
        NOP
        MOV     R0,R2
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R0,R3
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R0,R4
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R0,R5
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R0,R6
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R0,R7
        RET
                IF SRCMODE
                NOP
                ENDIF
        LJMP    Read_R8
        NOP
        LJMP    Read_R9
        NOP
        LJMP    Read_R10
        NOP
        LJMP    Read_R11
        NOP
        MOV     R0,R12
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R0,R13
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R0,R14
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R0,R15
        RET
                IF SRCMODE
                NOP
                ENDIF
Read_R0:
        MOV     DR8,SPX
        SUB     DR8,#0003                       ; Stack -3
        MOV     R0,@DR8
        RET
Read_R1:
        MOV     DR8,SPX
        DEC     DR8,#2                          ; Stack -2
        MOV     R0,@DR8
        RET
Read_R8:
        MOV     DR8,SPX
        SUB     DR8,#0007                       ; Stack -7
        MOV     R0,@DR8
        RET
Read_R9:
        MOV     DR8,SPX
        SUB     DR8,#0006                       ; Stack -6
        MOV     R0,@DR8
        RET
Read_R10:
        MOV     DR8,SPX
        SUB     DR8,#0005                       ; Stack -5
        MOV     R0,@DR8
        RET
Read_R11:
        MOV     DR8,SPX
        DEC     DR8,#4                          ; Stack -4
        MOV     R0,@DR8
        RET
;
Write_REG_table:
        LJMP    Write_R0
        NOP
        LJMP    Write_R1
        NOP
        MOV     R2,R0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R3,R0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R4,R0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R5,R0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R6,R0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R7,R0
        RET
                IF SRCMODE
                NOP
                ENDIF
        LJMP    Write_R8
        NOP
        LJMP    Write_R9
        NOP
        LJMP    Write_R10
        NOP
        LJMP    Write_R11
        NOP
        MOV     R12,R0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R13,R0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R14,R0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     R15,R0
        RET
                IF SRCMODE
                NOP
                ENDIF
Write_R0:
        MOV     DR8,SPX
        SUB     DR8,#0003
        MOV     @DR8,R0
        RET
Write_R1:
        MOV     DR8,SPX
        DEC     DR8,#2                          ; Stack -2
        MOV     @DR8,R0
        RET
Write_R8:
        MOV     DR8,SPX
        SUB     DR8,#0007
        MOV     @DR8,R0                         ; Stack -7
        RET
Write_R9:
        MOV     DR8,SPX
        SUB     DR8,#0006                       ; Stack -6
        MOV     @DR8,R0
        RET
Write_R10:
        MOV     DR8,SPX
        SUB     DR8,#0005                       ; Stack -5
        MOV     @DR8,R0
        RET
Write_R11:
        MOV     DR8,SPX
        SUB     DR8,#0004                       ; Stack -4
        MOV     @DR8,R0
        RET
;
Read_WR_table:
        LJMP    Read_WR0
        NOP
        MOV     WR0,WR2
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR0,WR4
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR0,WR6
        RET
                IF SRCMODE
                NOP
                ENDIF
        LJMP    Read_WR8
        NOP
        LJMP    Read_WR10
        NOP
        MOV     WR0,WR12
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR0,WR14
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR0,WR16
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR0,WR18
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR0,WR20
        RET                  
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR0,WR22
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR0,WR24
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR0,WR26
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR0,WR28
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR0,WR30
        RET
                IF SRCMODE
                NOP
                ENDIF
;
Read_WR0:
        MOV     DR8,SPX
        SUB     WR10,#0003H
        MOV     WR0,@DR8
        RET
Read_WR8:
        MOV     DR8,SPX
        SUB     WR10,#0007H
        MOV     WR0,@DR8
        RET
Read_WR10:
        MOV     DR8,SPX
        SUB     WR10,#0005H
        MOV     WR0,@DR8
        RET
;
Write_WR_table:
        LJMP    Write_WR0
        NOP
        MOV     WR2,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR4,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR6,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        LJMP    Write_WR8
        NOP
        LJMP    Write_WR10
        NOP
        MOV     WR12,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR14,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR16,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR18,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR20,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR22,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR24,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR26,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR28,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
        MOV     WR30,WR0
        RET
                IF SRCMODE
                NOP
                ENDIF
;
Write_WR0:
        MOV     DR8,SPX
        SUB     WR10,#0003H
        MOV     @DR8,WR0
        RET
Write_WR8:
        MOV     DR8,SPX
        SUB     WR10,#0007H
        MOV     @DR8,WR0
        RET
Write_WR10:
        MOV     DR8,SPX
        SUB     WR10,#0005H
        MOV     @DR8,WR0
        RET
;
;
;        ORG     0FF0C00H
Instruction_table:
; Special Function Register Read Commands
;----------------------------------------
        MOV     R0,080H                  ;00
        RET
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,081H                  ;01
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,082H                  ;02
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,083H                  ;03
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,084H                  ;04
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,085H                  ;05
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,086H                  ;06
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,087H                  ;07
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,088H                  ;08
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,089H                  ;09
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,08AH                  ;0A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,08BH                  ;0B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,08CH                  ;0C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,08DH                  ;0D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,08EH                  ;0E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,08FH                  ;0F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,090H                  ;10
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,091H                  ;11
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,092H                  ;12
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,093H                  ;13
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,094H                  ;14
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,095H                  ;15
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,096H                  ;16
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,097H                  ;17
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,098H                  ;18
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,099H                  ;19
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,09AH                  ;1A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,09BH                  ;1B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,09CH                  ;1C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,09DH                  ;1D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,09EH                  ;1E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,09FH                  ;1F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0A0H                  ;20
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0A1H                  ;21
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0A2H                  ;22
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0A3H                  ;23
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0A4H                  ;24
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0A5H                  ;25
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0A6H                  ;26
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0A7H                  ;27
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0A8H                  ;28
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0A9H                  ;29
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0AAH                  ;2A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0ABH                  ;2B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0ACH                  ;2C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0ADH                  ;2D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0AEH                  ;2E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0AFH                  ;2F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0B0H                  ;30
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0B1H                  ;31
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0B2H                  ;32
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0B3H                  ;33
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0B4H                  ;34
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0B5H                  ;35
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0B6H                  ;36
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0B7H                  ;37
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0B8H                  ;38
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0B9H                  ;39
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0BAH                  ;3A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0BBH                  ;3B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0BCH                  ;3C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0BDH                  ;3D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0BEH                  ;3E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0BFH                  ;3F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0C0H                  ;40
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0C1H                  ;41
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0C2H                  ;42
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0C3H                  ;43
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0C4H                  ;44
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0C5H                  ;45
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0C6H                  ;46
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0C7H                  ;47
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0C8H                  ;48
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0C9H                  ;49
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0CAH                  ;4A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0CBH                  ;4B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0CCH                  ;4C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0CDH                  ;4D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0CEH                  ;4E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0CFH                  ;4F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0D0H                  ;50
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0D1H                  ;51
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0D2H                  ;52
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0D3H                  ;53
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0D4H                  ;54
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0D5H                  ;55
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0D6H                  ;56
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0D7H                  ;57
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0D8H                  ;58
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0D9H                  ;59
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0DAH                  ;5A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0DBH                  ;5B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0DCH                  ;5C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0DDH                  ;5D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0DEH                  ;5E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0DFH                  ;5F
        RET 
                IF !SRCMODE
                NOP                  
                ENDIF
        MOV     R0,0E0H                  ;60
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0E1H                  ;61
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0E2H                  ;62
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0E3H                  ;63
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0E4H                  ;64
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0E5H                  ;65
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0E6H                  ;66
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0E7H                  ;67
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0E8H                  ;68
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0E9H                  ;69
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0EAH                  ;6A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0EBH                  ;6B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0ECH                  ;6C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0EDH                  ;6D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0EEH                  ;6E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0EFH                  ;6F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0F0H                  ;70
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0F1H                  ;71
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0F2H                  ;72
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0F3H                  ;73
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0F4H                  ;74
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0F5H                  ;75
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0F6H                  ;76
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0F7H                  ;77
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0F8H                  ;78
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0F9H                  ;79
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0FAH                  ;7A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0FBH                  ;7B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0FCH                  ;7C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0FDH                  ;7D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0FEH                  ;7E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     R0,0FFH                  ;7F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
;
;
Write_SFR_table:
;---------------
        MOV     080H,R0           ;00
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     081H,R0           ;01
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     082H,R0           ;02
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     083h,R0           ;03
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     084H,R0           ;04
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     085H,R0           ;05
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     086H,R0           ;06
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     087H,R0           ;07
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     088H,R0           ;08
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     089H,R0           ;09
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     08AH,R0           ;0A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     08BH,R0           ;0B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     08CH,R0           ;0C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     08DH,R0           ;0D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     08EH,R0           ;0E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     08FH,R0           ;0F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     090H,R0           ;10
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     091H,R0           ;11
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     092H,R0           ;12
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     093h,R0           ;13
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     094H,R0           ;14
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     095H,R0           ;15
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     096H,R0           ;16
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     097H,R0           ;17
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     098H,R0           ;18
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     099H,R0           ;19
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     09AH,R0           ;1A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     09BH,R0           ;1B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     09CH,R0           ;1C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     09DH,R0           ;1D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     09EH,R0           ;1E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     09FH,R0           ;1F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0A0H,R0           ;20
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0A1H,R0           ;21
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0A2H,R0           ;22
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0A3h,R0           ;23
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0A4H,R0           ;24
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0A5H,R0           ;25
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0A6H,R0           ;26
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0A7H,R0           ;27
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0A8H,R0           ;28
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0A9H,R0           ;29
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0AAH,R0           ;2A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0ABH,R0           ;2B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0ACH,R0           ;2C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0ADH,R0           ;2D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0AEH,R0           ;2E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0AFH,R0           ;2F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0B0H,R0           ;30
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0B1H,R0           ;31
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0B2H,R0           ;32
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0B3h,R0           ;33
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0B4H,R0           ;34
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0B5H,R0           ;35
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0B6H,R0           ;36
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0B7H,R0           ;37
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0B8H,R0           ;38
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0B9H,R0           ;39
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0BAH,R0           ;3A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0BBH,R0           ;3B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0BCH,R0           ;3C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0BDH,R0           ;3D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0BEH,R0           ;3E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0BFH,R0           ;3F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0C0H,R0           ;40
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0C1H,R0           ;41
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0C2H,R0           ;42
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0C3h,R0           ;43
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0C4H,R0           ;44
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0C5H,R0           ;45
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0C6H,R0           ;46
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0C7H,R0           ;47
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0C8H,R0           ;48
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0C9H,R0           ;49
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0CAH,R0           ;4A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0CBH,R0           ;4B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0CCH,R0           ;4C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0CDH,R0           ;4D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0CEH,R0           ;4E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0CFH,R0           ;4F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0D0H,R0           ;50
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0D1H,R0           ;51
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0D2H,R0           ;52
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0D3h,R0           ;53
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0D4H,R0           ;54
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0D5H,R0           ;55
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0D6H,R0           ;56
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0D7H,R0           ;57
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0D8H,R0           ;58
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0D9H,R0           ;59
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0DAH,R0           ;5A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0DBH,R0           ;5B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0DCH,R0           ;5C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0DDH,R0           ;5D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0DEH,R0           ;5E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0DFH,R0           ;5F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0E0H,R0           ;60
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0E1H,R0           ;61
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0E2H,R0           ;62
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0E3h,R0           ;63
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0E4H,R0           ;64
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0E5H,R0           ;65
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0E6H,R0           ;66
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0E7H,R0           ;67
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0E8H,R0           ;68
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0E9H,R0           ;69
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0EAH,R0           ;6A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0EBH,R0           ;6B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0ECH,R0           ;6C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0EDH,R0           ;6D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0EEH,R0           ;6E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0EFH,R0           ;6F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0F0H,R0           ;70
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0F1H,R0           ;71
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0F2H,R0           ;72
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0F3h,R0           ;73
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0F4H,R0           ;74
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0F5H,R0           ;75
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0F6H,R0           ;76
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0F7H,R0           ;77
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0F8H,R0           ;78
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0F9H,R0           ;79
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0FAH,R0           ;7A
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0FBH,R0           ;7B
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0FCH,R0           ;7C
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0FDH,R0           ;7D
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0FEH,R0           ;7E
        RET 
                IF !SRCMODE
                NOP
                ENDIF
        MOV     0FFH,R0           ;7F
        RET 
                IF !SRCMODE
                NOP
                ENDIF
;
User_code:
        nop                     ; user code may be placed here
        end
